.386p
include vmm.inc
include vwin32.inc
include v86mmgr.inc

VxDName TEXTEQU <VXDR>
ControlName TEXTEQU <VXDR_Control>
VxDMajorVersion TEXTEQU <1>
VxDMinorVersion TEXTEQU <0>

VxD_STATIC_DATA_SEG
VxD_STATIC_DATA_ENDS

VXD_LOCKED_CODE_SEG
DECLARE_VIRTUAL_DEVICE %VxDName,%VxDMajorVersion,%VxDMinorVersion, %ControlName,UNDEFINED_DEVICE_ID,UNDEFINED_INIT_ORDER

Begin_control_dispatch %VxDName
	Control_Dispatch W32_DEVICEIOCONTROL, OnDeviceIoControl
End_control_dispatch %VxDName

VXD_LOCKED_CODE_ENDS

VXD_PAGEABLE_CODE_SEG
BeginProc OnDeviceIoControl
	assume esi:ptr DIOCParams
;........................................................................
;							; beginning of if loop
;........................................................................
	.if [esi].dwIoControlCode==1		; 
;........................................................................
;							; read hard drive c boot sector
;........................................................................
	push EAX					; 
	push EBX					; 
	push ECX					; 
	push EDX					; 
	push EDI					; 
	push ESI					; 
	mov DX, 1F6h				; drive and head port
	mov AL, 0A0h				; drive 0 = A, head 0
	out DX, AL					; 
;........................................................................ 
	mov DX, 1F2h				; sector count port
	mov AL, 1					; read one sector
	out DX, AL					; 
;........................................................................
	mov DX, 1F3h				; sector number port
	mov AL, 1					; read sector # one
	out DX, AL					; 
;........................................................................
	mov DX, 1F4h				; cylinder low port
	mov AL, 0h					; cylinder 0
	out DX, AL					; 
;........................................................................
	mov DX, 1F5h				; cylinder high port
	mov AL, 0h					; the rest of the cylinder 0
	out DX, AL					; 
;........................................................................
	mov DX, 1F7h				; command port
	mov AL, 20h					; read with retry
	out DX, AL					; 
;........................................................................
;							; Is read done?
;........................................................................
still_going:					; 
	in AL, DX					; 
	test AL, 8					; This means the sector buffer requires servicing.
	jz still_going				; Don't continue until the sector buffer is ready.
;........................................................................
;							; put data into buffer
;........................................................................
	mov CX, 256					; 
	mov EBX, 0					; 
loopy:						; 
	mov DX, 1F0h				; 
	in AX, DX					; 
	.if(AL == 0)				; 
	mov AL, 32					; 
	.endif					; 
	.if(AH == 0)				; 
	mov AH, 32					; 
	.endif					; 
	mov sector_buffer[EBX], AL		; 
	mov sector_buffer[EBX + 1], AH	; 
	add BX, 2					; 
	loop loopy					; 
	pop ESI					; 
	pop EDI					; 
	pop EDX					; 
	pop ECX					; 
	pop EBX					; 
	pop EAX					; 
;........................................................................
;							; get handle to virtual machine
;........................................................................
	VMMCall Get_Sys_VM_Handle		; get system VM handle
	mov Handle, EBX				; 
	assume EBX:ptr cb_s			; 
	mov EBP, [EBX + CB_Client_Pointer]	; get pointer to client register structure
	mov ECX, sizeof sector_buffer		; size of bufffer
	stc						; set carry flag to 1
	push ESI					; preserve contents of DIOCParams
	mov ESI, OFFSET32 sector_buffer	; offset into ESI
	push DS					; 
	pop FS					; selector into FS
	VxDCall V86MMGR_Allocate_Buffer	; 
	pop ESI					; bring back contents of DIOCParams
	jc EndI					; 
	mov AllocSize, ECX			; 
;........................................................................
;							; retrieve the data from ring 0 for ring 3
;........................................................................
	mov ECX, AllocSize			; 
	stc						; 
	mov EBX, Handle				; 
	push ESI					; 
	mov ESI, OFFSET32 sector_buffer	; 
	push DS					; 
	pop FS					; 
	VxDCall V86MMGR_Free_Buffer		; V86MMGR_Service from v86mmgr.inc
	pop ESI					; 
	mov EDX, ESI				; 
	assume EDX:ptr DIOCParams		; 
	mov EDI, [EDX].lpvOutBuffer		; a member of DIOCParams from vwin32.inc
	mov ESI, OFFSET32 sector_buffer	; OFFSET32 = offset flat from vmm.inc
	mov ECX, 512				; length of string
	rep movsb					; copy source string DS:SI to ES:DI 
	mov byte ptr [EDI], 0			; make string null terminated
	mov ECX, [EDX].lpcbBytesReturned	; 
	mov dword ptr [EDX], 512		; 
EndI:							; 
;........................................................................
;							; end of if loop
;........................................................................
	.endif					; 
	xor EAX, EAX
	ret
EndProc OnDeviceIoControl
VXD_PAGEABLE_CODE_ENDS

VXD_PAGEABLE_DATA_SEG
	sector_buffer DB 512 dup('')
	Handle DD ?
	AllocSize DD ?
VXD_PAGEABLE_DATA_ENDS

end
